﻿Type=Class
Version=1.2
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private pnlCheckbox As Panel
	Private lblText As Label
	Private Img As ImageView
	Private mChecked As Boolean
	Private imgChecked, ingUnChecked As Bitmap
	
	Private mModule As Object
	Private mEventName As String
	Private mEnabled As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Module As Object,Parent As Panel,EventName As String,Left As Int,Top As Int,Width As Int,Height As Int,Checked As Boolean)

	mChecked = Checked
	mModule = Module
	mEventName = EventName
	mEnabled = True
	
	ingUnChecked = LoadBitmap(File.DirAssets,"checkBox.png")
	imgChecked = LoadBitmap(File.DirAssets,"checkBoxMarked.png")

	Img.Initialize("")
	lblText.Initialize("")
	lblText.Text = ""

	pnlCheckbox.Initialize("pnlCheckbox")
	pnlCheckbox.AddView(Img, 0, 0, Height, Height)
	pnlCheckbox.AddView(lblText, Height + 5dip, 0, Width - (Height + 5dip), Height)
	pnlCheckbox.Tag = Me
	Parent.AddView(pnlCheckbox, Left, Top, Width, Height)
	LoadImage
	
	Log("mChecked= " & mChecked)
End Sub

Sub AsView As View
	Return pnlCheckbox
End Sub

Private Sub LoadImage
	If mChecked Then
		Img.Bitmap = imgChecked 
	Else
		Img.Bitmap = ingUnChecked
	End If
	
	setEnabled(mEnabled)
End Sub

Private Sub pnlCheckbox_Click
	If Not(mEnabled) Then Return
	
	mChecked = Not(mChecked)
	LoadImage
	If SubExists(mModule,mEventName & "_CheckedChange", 1) Then
		CallSub2(mModule,mEventName & "_CheckedChange", mChecked)
	End If
End Sub

Public Sub setChecked(Checked As Boolean)
	mChecked = Checked
	LoadImage
End Sub

Public Sub getChecked As Boolean
	Log("mChecked= " & mChecked)
	Return mChecked
End Sub

Public Sub setEnabled(Enabled As Boolean)
	Dim Alpha As Float
	mEnabled = Enabled
	If mEnabled Then
		Alpha = 1
	Else
		Alpha = 0.3
	End If
	Img.Alpha = Alpha
	lblText.Alpha = Alpha
	Log(mEnabled)
End Sub

Public Sub getEnabled As Boolean
	Return mEnabled
End Sub

Public Sub getText As String
	Return lblText.Text
End Sub

Public Sub setText(text As String)
	lblText.text = text
End Sub

Public Sub setVisible(Visible As Boolean)
	pnlCheckbox.Visible = Visible
End Sub

Public Sub getVisible As Boolean
	Return pnlCheckbox.Visible
End Sub

Public Sub setTag(Tag As Object)
	pnlCheckbox.Tag = Tag
End Sub

Public Sub getTag As Object
	Return pnlCheckbox.Tag
End Sub